/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.niederschrift;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.niederschrift.boundary.AbstractNiederschriftSearchParameters;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftChangeEvent;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftConversationStore;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftExtendedDAO;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftSearch;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.niederschrift.entity.Niederschrift;
import de.ivu.elect.business.niederschrift.entity.NiederschriftMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractNiederschriftSearchView.COMPONENT_NAME)
@View(viewId = AbstractNiederschriftSearchView.VIEW_ID, useCase = UseCasePermission.NIEDERSCHRIFT_SEARCH)
public abstract class AbstractNiederschriftSearchView extends AbstractElectSearchView<Niederschrift> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "niederschriftSearchView";
  
  public static final String VIEW_ID = "/niederschrift/niederschrift-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractNiederschriftSearchView requestHandler;

  @Inject
  private transient NiederschriftExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(NiederschriftConversationStore.class)
  protected transient NiederschriftConversationStore conversationStore;

  @Inject
  protected transient NiederschriftSearch search;

  @Inject
  @ConversationGroup(AbstractNiederschriftSearchParameters.class)
  protected transient NiederschriftSearchParameters searchParameters;

  @Inject
  protected transient NiederschriftMeta entityMeta;

  public AbstractNiederschriftSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Niederschrift getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Niederschrift entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public NiederschriftSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Niederschrift> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Niederschrift> create();
  }

  @Override
  public List<Niederschrift> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Niederschrift> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onNiederschriftChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) NiederschriftChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractNiederschriftSearchView {

    @View
    @Inject
    private transient Instance<AbstractNiederschriftSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractNiederschriftSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
